
#include <lubishev/Exception.h>

#include <QTextStream>

namespace lubishev {

Exception::Exception(const QString &type,
                     const QString &desc,
                     const QString &src,
                     const QString &file,
                     int line) :
        mType(type),
        mDesc(desc) {
    QTextStream msg(&mMsg);
    msg << "Lubishev exception (" << type << "): " << desc
        << " in " << src << " at " << file << ":"
        << QString("%1").arg(line);
}

QString Exception::getDesc() const {
    return mDesc;
}

QString Exception::getType() const {
    return mType;
}

const char* Exception::what() const throw() {
    return mMsg.toUtf8().constData();
}

} // namespace lubishev

